View Issue Details

IDProjectCategoryView StatusLast Update
0000705SOGoSOPEpublic2010-08-30 16:32
Reporterib_pl Assigned Towsourdeau 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
Product Version1.3.0 
Fixed in Version1.3.2 
Summary0000705: SOPE/SOGo 1.3.0 building problems
Description

Hello,

Can you please verify SOGo compilation hints on page

http://www.sogo.nu/english/support/faq/article/how-do-i-compile-sogo.html (*)

update it and verify my fixes to SOGo building process?

My questions/problems regarding building 1.3.0:

(1)
I've installed
gnustep-make-2.4.0.tar.gz
gnustep-base-1.20.1.tar.gz
gcc 4.5.0
openssl
openldap

(2)
I've downloaded SOPE-1.3.0.tar.gz and SOGo-1.3.0.tar.gz from

http://www.sogo.nu/english/downloads/backend.html

Patched SOPE:
patch -p0 < SOGO_DIR/SOPE/sope-gsmake2.diff
patch -p0 < SOGO_DIR/SOPE/sope-patchset-r1664.diff

/it this ok and enough or patching SOPE-1.3.0.tar.gz is not required?/.

(3)
Compilation of patched SOPE failed with error

Making all for subproject WebDAV...
Compiling file SoWebDAVRenderer.m ...
SoWebDAVRenderer.m:28:31: fatal error: NGObjWeb/SoObject.h: No such file or directory

so i've changed line 7964 in SOGO_DIR/SOPE/sope-patchset-r1664.diff from

+#include <NGObjWeb/SoObject.h>

to

+#include <NGObjWeb/SoObjects/SoObject.h>

/is this fix ok or not?/, unpacked and patched SOPE-1.3.0.tar.gz again.

(4)
Compilation of patched SOPE failed with error

   Making all for tool wod...
    Linking tool wod ...
   ../../sope-core/NGExtensions/./obj/libNGExtensions.so: undefined reference to `behavior_class_add_class'

I think it's because lack of behavior.h in gnustep-base-1.20.1. From gnustep-base changelog:

 2010-03-01 Richard Frith-Macdonald &lt;rfm@gnu.org>

    * Headers/Additions/GNUstepBase/behavior.h:
    * Source/Additions/behavior.m:
    * Source/Additions/GNUmakefile:
    Remove obsolete, unused, and long deprecated code.
    The functinality is still present in GSObjCRuntime.[hm]

Please consider updating info about required/compatible/recommended gnustep packages on page (*).

So I started all process from the beginning but with

gnustep-base-1.18.0.tar.gz

(5)
Compilation of SOGO finished ok. Compilation of SOGO failed with error:

Making all for wobundle Appointments...
make[3]: *** No rule to make target `obj', needed by `internal-wobundle-all_'.  Stop.
make[2]: *** [Appointments.all.wobundle.variables] Error 2
make[1]: *** [internal-all] Error 2
make: *** [internal-all] Error 2

So I started all process from the beginning but with

gnustep-make-2.2.0.tar.gz

(6)
Compilation of SOGO finished ok. After starting SOGo I got many errors in log. After searching then net I found

http://www.mail-archive.com/users@sogo.nu/msg00785.html

Please consider creating UPGRADE file in source root with upgrade instructions or putting UPGRADE chapter it in PDF manual.

Now, after fixes as above SOGo 1.3.0 seems to work ok.

Regards,
Pawel

TagsNo tags attached.

Relationships

related to 0000632 resolvedwsourdeau wobundle.make not compatible with gnustep-make 2.4.0 

Activities

wsourdeau

wsourdeau

2010-07-23 12:59

viewer   ~0001224

We haven't tested gcc 4.5 nor gnustep-base 1.21. SOGo is developed using gnustep-base 1.19.3 and gcc 4.4, although I think the version number of gcc does not matter much.

Also, you should know that gnustep-make 2.4 poses problems that are still yet to resolve.

Regarding the SQL script, we should indeed update the documentation for this but this has already been mentionned on the mailing-list where your message would pertain more than here. Besides, the announce of 1.3 includes information on the upgrade procedure.

Finally, why don't you use one or our binary packages?

ib_pl

ib_pl

2010-07-23 16:50

reporter   ~0001235

Thank you for pointing recommended gcc and gnustep-base versions. Would be nice to see it in PDF docs or REQUIREMENTS file with other recommendations (i.e. gnustep-make) to allow people save time trying wrong versions.

BTW: don't you think (3) as above should be fixed?

Finally, why don't you use one or our binary packages?

Custom linux distro + security procedures + a few our patches still not applied to SOGo mainstream:

Thank you for great tool,
Pawel

steeeeeveee

steeeeeveee

2010-08-13 20:52

reporter   ~0001302

The GCC version is not the problem. I use GCC 4.5.1 and as soon as I use a recent gnustep-base and gnustep-make edition I can not compile SOPE nor SOGo. The highest version that has no issues is gnustep-base 1.19.3 and gnustep-make 2.2.0. Anything higher than that is not working.

buzzdee

buzzdee

2010-08-19 13:04

reporter   ~0001313

I'm in the process of creating a port for sope/sogo to OpenBSD. I ran into the same problem. The gnustep-base version there is 1.20.1.

I'll take a look

2010-08-19 13:59

 

patch-sope-core_NGExtensions_NGObjCRuntime_m (710 bytes)   
$OpenBSD$

Make it compatible with newer gnustep-base again

--- sope-core/NGExtensions/NGObjCRuntime.m.orig	Mon Jul  3 21:34:05 2006
+++ sope-core/NGExtensions/NGObjCRuntime.m	Thu Aug 19 19:57:31 2010
@@ -49,9 +49,9 @@ typedef struct objc_method      *Method_t;
 #if GNUSTEP_BASE_LIBRARY
 /* this is a hack for the extensions 0.8.6 library */
 
-void class_add_behavior(Class class, Class behavior) {
-  extern void behavior_class_add_class (Class class, Class behavior);
-  behavior_class_add_class(class, behavior);
+void class_add_behavior(Class receiver, Class behavior) {
+  extern void GSObjCAddClassBehavior (Class receiver, Class behavior);
+  GSObjCAddClassBehavior(receiver, behavior);
 }
 
 #endif
buzzdee

buzzdee

2010-08-19 14:01

reporter   ~0001314

Attached patch fixes the compilation issue for me with gnustep-base-1.20.1 on OpenBSD. When I understand the changelog correctly, this should also work with the older version of gnustep-base

wsourdeau

wsourdeau

2010-08-30 16:32

viewer   ~0001397

The build is now working on both GNUstep 1.20 and above, and below. Both SOPE and SOGo have been adapted, but you need to use the SOPE source from our source repository of course.

Issue History

Date Modified Username Field Change
2010-07-23 12:46 ib_pl New Issue
2010-07-23 12:59 wsourdeau Note Added: 0001224
2010-07-23 12:59 wsourdeau Status new => closed
2010-07-23 12:59 wsourdeau Resolution open => won't fix
2010-07-23 16:50 ib_pl Note Added: 0001235
2010-07-23 16:50 ib_pl Status closed => feedback
2010-07-23 16:50 ib_pl Resolution won't fix => reopened
2010-08-13 20:52 steeeeeveee Note Added: 0001302
2010-08-19 13:04 buzzdee Note Added: 0001313
2010-08-19 13:59 buzzdee File Added: patch-sope-core_NGExtensions_NGObjCRuntime_m
2010-08-19 14:01 buzzdee Note Added: 0001314
2010-08-26 16:27 wsourdeau Relationship added related to 0000632
2010-08-30 16:32 wsourdeau Note Added: 0001397
2010-08-30 16:32 wsourdeau Status feedback => resolved
2010-08-30 16:32 wsourdeau Fixed in Version => 1.3.2
2010-08-30 16:32 wsourdeau Resolution reopened => fixed
2010-08-30 16:32 wsourdeau Assigned To => wsourdeau